#ifndef CLccubes_H__
#define CLccubes_H__

#include "cl_setup.h"

#ifndef _MSC_VER
#include <stdint.h>
#else
#include <stdint_msvc.h>
#endif

#define ROW_DIM 0
#define COL_DIM 1

struct ccubes_context {
	struct cl_uctx *clctx;

	cl_program ccubes_program;
	cl_kernel ccubes_task;

	/* internal memory sizes */
	int k;
	int ninputs;
	int posrows;
	int negrows;
	int implicant_words;
	int value_bit_width;
	int pichart_words;

	/* INPUTS */
	cl_mem nofvalues;
	cl_mem ON_set;
	cl_mem OFF_set;
	cl_mem p_implicants_pos;
	cl_mem p_implicants_val;
	cl_mem last_index;
	cl_mem p_covered;
	cl_mem p_pichart_pos;

	/* OUTPUTS */
	cl_mem coverage;
	cl_mem fixed_bits;
	cl_mem value_bits;
	cl_mem pichart_values;

	/* Host outputs */
	bool *h_coverage;
	unsigned int *h_fixed_bits;
	unsigned int *h_value_bits;
	unsigned int *h_pichart_values;

	/* ND-Range */
	size_t gws; 	/* global work size */
};

int ccubes(void);

int
clccubes(struct ccubes_context *ccubesctx, cl_mem alpha0, cl_mem G, size_t signals,
    size_t atoms, uint32_t sparsity, uint32_t pcoding, cl_mem gamma, cl_uint
    num_events_in_wait_list, const cl_event *event_wait_list, cl_event *ev_ccubes);

#endif
